diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/IDefinedTerm.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/IDefinedTerm.java
index 55443ed932..f3d8a0f36e 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/IDefinedTerm.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/IDefinedTerm.java
@@ -10,33 +10,14 @@
 package eu.etaxonomy.cdm.model.common;
 
 import java.util.Set;
-import java.util.UUID;
-
-import javax.persistence.Transient;
-
 
 import eu.etaxonomy.cdm.model.media.Media;
 
-public interface IDefinedTerm<T extends IDefinedTerm> extends ILoadableTerm<T> {
-
-	@Transient
-	public UUID getUuid();
-	
-	public T getByUuid(UUID uuid);
+public interface IDefinedTerm<T extends IDefinedTerm> extends ISimpleTerm<T>, ILoadableTerm<T> {
 
-	/**
-	 * Returns the defined term this term is a kind of.
-	 * Therefore the returned term is a generalization of <code>this</code> term
-	 */
-	public T getKindOf();
 
 //	public void setKindOf(T kindOf);
 
-	/**
-	 * Returns all defined terms this term is a generalization for.
-	 * Therefore the returned terms are kind of <code>this</code> term
-	 */
-	public Set<T> getGeneralizationOf();
 
 //	public void setGeneralizationOf(Set<T> generalizationOf);
 //
@@ -47,7 +28,10 @@ public interface IDefinedTerm<T extends IDefinedTerm> extends ILoadableTerm<T> {
 	/**
 	 * Returns the defined term this term is a part of.
 	 * Therefore the returned term includes <code>this</code> term
+	 * Discuss: move to {@link ISimpleTerm}?
+	 * @see #getIncludes()
 	 */
+	//Discuss: move to ISimpleTerm
 	public T getPartOf();
 
 //	public void setPartOf(T partOf);
@@ -55,6 +39,8 @@ public interface IDefinedTerm<T extends IDefinedTerm> extends ILoadableTerm<T> {
 	/**
 	 * Returns all defined terms this term includes.
 	 * Therefore the returned terms are part of <code>this</code> term
+	 * Discuss: move to {@link ISimpleTerm}?
+	 * @see #getPartOf()
 	 */
 	public Set<T> getIncludes();
 
@@ -64,6 +50,10 @@ public interface IDefinedTerm<T extends IDefinedTerm> extends ILoadableTerm<T> {
 //
 //	public void removeIncludes(T includes);
 
+	/**
+	 * Returns the media attached to this {@link IDefinedTerm term}
+	 * @return
+	 */
 	public Set<Media> getMedia();
 
 //	public void setMedia(Set<Media> media);
@@ -81,5 +71,18 @@ public interface IDefinedTerm<T extends IDefinedTerm> extends ILoadableTerm<T> {
 	 * @see eu.etaxonomy.cdm.model.common.IDefTerm#setVocabulary(eu.etaxonomy.cdm.model.common.TermVocabulary)
 	 */
 //	public void setVocabulary(TermVocabulary<T> newVocabulary);
+	
+	/**
+	 * Returns the label of this term used (and unique) in the term's vocabulary.
+	 * @see #setIdInVocabulary(String)
+	 */
+	public String getIdInVocabulary();
+	
+	/**
+	 * Sets the label of this term used (and unique) in the term's vocabulary.
+	 * @see #getIdInVocabulary()
+	 * @param idInVocabulary
+	 */
+	public void setIdInVocabulary(String idInVocabulary);
 
 }
\ No newline at end of file
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/IEnumTerm.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/IEnumTerm.java
new file mode 100644
index 0000000000..1bcf9be779
--- /dev/null
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/IEnumTerm.java
@@ -0,0 +1,19 @@
+/**
+ * 
+ */
+package eu.etaxonomy.cdm.model.common;
+
+
+/**
+ * Interface to combine {@link ISimpleTerm} and {@link IKeyTerm} properties.
+ * To be used by enumerated terms.
+ * 
+ * @author a.mueller
+ * @created 15-Jul-2013
+ *
+ */
+public interface IEnumTerm<T extends IEnumTerm<T>> extends ISimpleTerm<T>, IKeyTerm {
+
+	
+	
+}
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/IIdentifiableEntity.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/IIdentifiableEntity.java
index f5d137fbe3..ac4755fd92 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/IIdentifiableEntity.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/IIdentifiableEntity.java
@@ -25,8 +25,11 @@ public interface IIdentifiableEntity extends ISourceable<IdentifiableSource>, IA
     public String getTitleCache();
 
     /**
-     * Sets the title cache without changing the <code>protectCache</code> flag
+     * Sets the title cache without changing the <code>protectCache</code> flag.
+     * If this flag is <code>false</code> the titleCache may be recomputed with the
+     * next call of {@link #getTitleCache()}
      * @see #setTitleCache(String, boolean)
+     * @see #getTitleCache()
      * @param titleCache
      */
     public void setTitleCache(String titleCache);
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/IKeyTerm.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/IKeyTerm.java
new file mode 100644
index 0000000000..767b4537fd
--- /dev/null
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/IKeyTerm.java
@@ -0,0 +1,48 @@
+/**
+ * 
+ */
+package eu.etaxonomy.cdm.model.common;
+
+import eu.etaxonomy.cdm.hibernate.EnumUserType;
+
+
+/**
+ * Interface for all enumerations which provide a key for persisting them as strings
+ * via {@link EnumUserType}.
+ * The key may also be used for other purposes.
+ * The key must be unique within the enumeration.
+ * 
+ * The interface also provides a human readable representation with i18n support.
+ * 
+ * IMPORTANT: classes implementing this interface must also implement a static method
+ * <code>getByKey(String)</code> which returns the according instance. This can not be 
+ * guaranteed by the interface as interfaces do not allow definitions of static methods.
+ * 
+ * @author a.mueller
+ * @created 30-Aug-2013
+ *
+ */
+public interface IKeyTerm  {
+
+	/**
+	 * Returns the key for the enumeration.
+	 * A key should be short unique identifier within the given enumeration. 
+	 * If not otherwise stated it should not be longer then 3 characters. 
+	 * @return the key
+	 */
+	public String getKey();
+	
+	/**
+	 * Returns a human readable preferably for the default language.
+	 * @return
+	 */
+	public String getMessage();	
+
+	/**
+	 * Returns a human readable preferably for the given language.
+	 * @param language
+	 * @return
+	 */
+	public String getMessage(Language language);
+
+}
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/ILoadableTerm.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/ILoadableTerm.java
index 421d79b0f2..dabc3590c5 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/ILoadableTerm.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/ILoadableTerm.java
@@ -23,7 +23,7 @@ public interface ILoadableTerm<T extends IDefinedTerm>{
 	 * @param csvLine
 	 * @return
 	 */
-	public T readCsvLine(Class<T> termClass, List<String> csvLine, Map<UUID,DefinedTermBase> terms);
+	public T readCsvLine(Class<T> termClass, List<String> csvLine, Map<UUID,DefinedTermBase> terms, boolean abbrevAsId);
 
 	public  void writeCsvLine(CSVWriter writer, T term);
 }
\ No newline at end of file
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/IOriginalSource.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/IOriginalSource.java
index 882eff6618..87679a8050 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/IOriginalSource.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/IOriginalSource.java
@@ -15,7 +15,7 @@ import eu.etaxonomy.cdm.model.reference.Reference;
 /**
  * An original source can be used in different ways.<BR>
  * 1.) As a referencing system. The original source holds all information about the reference, 
- * the microReference (page, figure, ...), the identifier used in for the referenced object in the 
+ * the microReference (page, figure, ...), the identifier used in the source for the referenced object in the 
  * reference, a namespace that makes this identifier unique, the original name string that in 
  * general stores the representation of the referenced object within the source (if the string representation
  * in the source differs from that one unsed in the CDM object)
@@ -24,18 +24,40 @@ import eu.etaxonomy.cdm.model.reference.Reference;
  * and it's namespace (e.g. tablename) as well as the datasource itself maybe stored in an original source.
  * E.g. when importing SDD data here you may store the filename and the id used in the SDD file here.
  *
+ * Starting with v3.3 we started to let this class be influenced by the PROV Ontology 
+ * (http://www.w3.org/TR/2013/NOTE-prov-overview-20130430/). It may move further in this direction in
+ * future. 
+ * The above mentioned ways to use the Original Source are now related to different activity types
+ * (http://www.w3.org/TR/2013/REC-prov-dm-20130430/#term-Activity) in PROV.
+ * 
+ * 
  * @author a.mueller
  * @created 18.09.2009
- * @version 1.0
  */
 public interface IOriginalSource<T extends ISourceable> {
 
 	/*************** GETTER /SETTER ************************************/
 
+	
+	/**
+	 * Returns the {@link OriginalSourceType type} of the source. The type defines the relationship
+	 * between the current data and the original data. 
+	 * @see OriginalSourceType 
+	 * @return the type of the source
+	 */
+	public OriginalSourceType getType();
+
+	/**
+	 * @see #getType()
+	 * @param type the type to be set
+	 */
+	public void setType(OriginalSourceType type);
+	
 	/**
 	 * Returns the (unique) identifier used in the source.
 	 * If the identifier is not unique, {@link #getIdNamespace() namespace} should be defined.
 	 * The namespace together with the identifier should be unique.
+	 * @return  the identifier used in the source.
 	 */
 	public String getIdInSource();
 
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/IReferencedEntity.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/IReferencedEntity.java
index df438d022c..04dc07c0d1 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/IReferencedEntity.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/IReferencedEntity.java
@@ -15,7 +15,6 @@ import eu.etaxonomy.cdm.model.reference.Reference;
 
 /**
  * @author m.doering
- * @version 1.0
  * @created 08-Nov-2007 13:06:30
  */
 public interface IReferencedEntity {
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/ISimpleTerm.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/ISimpleTerm.java
new file mode 100644
index 0000000000..431915ca1b
--- /dev/null
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/ISimpleTerm.java
@@ -0,0 +1,61 @@
+/**
+ * 
+ */
+package eu.etaxonomy.cdm.model.common;
+
+import java.util.Set;
+import java.util.UUID;
+
+import javax.persistence.Transient;
+
+/**
+ * The common interface which is implemented by {@link DefinedTermBase defined terms} and enumerations
+ * replacing fully {@link DefinedTermBase defined terms}.
+ * 
+ * @author a.mueller
+ * @created 14-Jul-1913
+ */
+public interface ISimpleTerm<T extends ISimpleTerm> {
+
+	@Transient
+	public UUID getUuid();
+	
+	//is static !!
+//	public T getByUuid(UUID uuid);
+
+
+	/**
+	 * Returns the defined term this term is a kind of.
+	 * Therefore the returned term is a generalization of <code>this</code> term
+	 */
+	public T getKindOf();
+	
+
+	/**
+	 * Returns all defined terms this term is a direct generalization for.
+	 * Therefore the returned terms are kind of <code>this</code> term.
+	 */
+	public Set<T> getGeneralizationOf();
+	
+
+	/**
+	 * Computes if <code>this</code> term is kind of the <code>ancestor</code> term.
+	 * So the <code>ancestor</code> term is direct or indirect (recursive) generalization
+	 * of <code>this</code> term.
+	 * @param ancestor the potential ancestor term
+	 * @see #getKindOf()
+	 * @see #getGeneralizationOf()
+	 */
+	public boolean isKindOf(T ancestor);
+	
+	/**
+	 * Returns all defined terms this term is a generalization for.
+	 * Therefore the returned terms are kind of <code>this</code> term.
+	 * If parameter <code>recursive</code> is <code>false</code> only the
+	 * direct descendants will be returned. If it is <code>true</code>
+	 * the direct descendants and there recursive descendants (all descendants)
+	 * will be returned. 
+	 */
+	public Set<T> getGeneralizationOf(boolean recursive);
+
+}
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/ISourceable.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/ISourceable.java
index c738bfe0a4..0ca85cab52 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/ISourceable.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/ISourceable.java
@@ -30,14 +30,16 @@ public interface ISourceable<T extends IOriginalSource> {
 	
 	
 	/**
-	 * Adds a source that is newly created by its components. If all components are <code>null</null>
+	 * Adds a source that is newly created by its components. If all components except for the 
+	 * type are <code>null</null>
 	 * no source is added.
-	 * @param id
-	 * @param idNamespace
-	 * @param citation
-	 * @param microCitation
+     * @param type the {@link OriginalSourceType type} of the source
+     * @param idInSource the id used in the source 
+     * @param idNamespace the namespace for the id in the source
+     * @param citation the source as a {@link Reference reference}
+     * @param microReference the details (e.g. page number) in the reference
 	 */
-	public T addSource(String id, String idNamespace, Reference citation, String microCitation);
+	public T addSource(OriginalSourceType type, String id, String idNamespace, Reference citation, String microCitation);
 		
 
 	/**
@@ -46,4 +48,16 @@ public interface ISourceable<T extends IOriginalSource> {
 	 */
 	public void removeSource(T source);
 
+    /**
+     * Adds a {@link IOriginalSource source} of {@link OriginalSourceType type} Import to this description element.
+     * 
+     * @param idInSource the id used in the source 
+     * @param idNamespace the namespace for the id in the source
+     * @param citation the source as a {@link Reference reference}
+     * @param microReference the details (e.g. page number) in the reference
+     * @param nameUsedInSource the taxon name used in the source
+     * @param originalNameString the name as text used in the source
+     */
+	public T addImportSource(String id, String idNamespace, Reference<?> citation, String microCitation);
+
 }
\ No newline at end of file
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/ITreeNode.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/ITreeNode.java
new file mode 100644
index 0000000000..a23ee9458e
--- /dev/null
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/ITreeNode.java
@@ -0,0 +1,77 @@
+// $Id$
+/**
+* Copyright (C) 2007 EDIT
+* European Distributed Institute of Taxonomy 
+* http://www.e-taxonomy.eu
+* 
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+package eu.etaxonomy.cdm.model.common;
+
+import java.util.Collection;
+import java.util.List;
+
+import org.hibernate.event.spi.SaveOrUpdateEventListener;
+
+/**
+ * Common interface for all tree data structures supporting tree indexing.
+ * Mainly used by {@link SaveOrUpdateEventListener} to update the indices.
+ * 
+ * @author a.mueller
+ * @created 12.08.2013
+ *
+ */
+public interface ITreeNode<T extends ITreeNode<T>> extends ICdmBase {
+	//Constants
+	public static final String separator = "#";
+	public static final String treePrefix = "t";
+	
+	
+	//METHODS
+	
+	
+	/**
+	 * Returns the tree index of this tree node.
+	 * @return the tree index
+	 */
+	public String treeIndex();
+
+	
+	/**
+	 * Returns the parent node of this node.
+	 * Returns <code>null</code> if this
+	 * node is a root node.
+	 * @return
+	 */
+	public ITreeNode<T> getParent();
+
+	/**
+	 * Sets the tree index of this node.
+	 * @deprecated preliminary implementation for updating the treeindex.
+	 * Maybe removed once index updating is improved.
+	 * @param newTreeIndex
+	 */
+	public void setTreeIndex(String newTreeIndex);
+	
+	/**
+	 * Returns all direct child nodes of this node.
+	 * As tree node children do not necessarily need to be
+	 * {@link List lists} the return type of this method may change
+	 * to {@link Collection} in future. Therefore the use
+	 * at the moment is deprecated.
+	 * @deprecated return type may become {@link Collection} in future 
+	 * @return the list of children
+	 */
+	public List<T> getChildNodes();
+
+	/**
+	 * Returns the {@link ICdmBase#getId() id} of the tree object,
+	 * this node belongs to.
+	 * @deprecated may be removed in future when index updating does not
+	 * use this anymore
+	 * @return the id of the tree
+	 */
+	public int treeId();
+
+}
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/IdentifiableEntity.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/IdentifiableEntity.java
index d2652d13b8..be326fcf2f 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/IdentifiableEntity.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/IdentifiableEntity.java
@@ -107,7 +107,7 @@ public abstract class IdentifiableEntity<S extends IIdentifiableEntityCacheStrat
     @Column(length=255, name="titleCache")
     @Match(value=MatchMode.CACHE, cacheReplaceMode=ReplaceMode.ALL)
     @NotEmpty(groups = Level2.class) // implictly NotNull
-    @Size(max = 255)
+    @Size(max = 800)  //see #1592
     @Fields({
         @Field(store=Store.YES),
         @Field(name = "titleCache__sort", analyze = Analyze.NO, store=Store.YES)
@@ -241,9 +241,9 @@ public abstract class IdentifiableEntity<S extends IIdentifiableEntityCacheStrat
      */
     @Transient
     protected String getTruncatedCache(String cache) {
-        if (cache != null && cache.length() > 255){
+        if (cache != null && cache.length() > 1023){
             logger.warn("Truncation of cache: " + this.toString() + "/" + cache);
-            cache = cache.substring(0, 252) + "...";
+            cache = cache.substring(0, 1020) + "...";
         }
         return cache;
     }
@@ -444,11 +444,25 @@ public abstract class IdentifiableEntity<S extends IIdentifiableEntityCacheStrat
      * @see eu.etaxonomy.cdm.model.common.ISourceable#addSource(java.lang.String, java.lang.String, eu.etaxonomy.cdm.model.reference.Reference, java.lang.String)
      */
     @Override
-    public IdentifiableSource addSource(String id, String idNamespace, Reference citation, String microCitation) {
+    public IdentifiableSource addSource(OriginalSourceType type, String id, String idNamespace, Reference citation, String microCitation) {
         if (id == null && idNamespace == null && citation == null && microCitation == null){
             return null;
         }
-        IdentifiableSource source = IdentifiableSource.NewInstance(id, idNamespace, citation, microCitation);
+        IdentifiableSource source = IdentifiableSource.NewInstance(type, id, idNamespace, citation, microCitation);
+        addSource(source);
+        return source;
+    }
+    
+    
+    /* (non-Javadoc)
+     * @see eu.etaxonomy.cdm.model.common.ISourceable#addImportSource(java.lang.String, java.lang.String, eu.etaxonomy.cdm.model.reference.Reference, java.lang.String)
+     */
+    @Override
+    public IdentifiableSource addImportSource(String id, String idNamespace, Reference<?> citation, String microCitation) {
+        if (id == null && idNamespace == null && citation == null && microCitation == null){
+            return null;
+        }
+        IdentifiableSource source = IdentifiableSource.NewInstance(OriginalSourceType.Import, id, idNamespace, citation, microCitation);
         addSource(source);
         return source;
     }
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/IdentifiableSource.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/IdentifiableSource.java
index 1528fe942b..af57f80098 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/IdentifiableSource.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/IdentifiableSource.java
@@ -46,36 +46,43 @@ public class IdentifiableSource extends OriginalSourceBase<IdentifiableEntity>{
 	@SuppressWarnings("unused")
 	private static final Logger logger = Logger.getLogger(IdentifiableSource.class);
 	
-
 	/**
 	 * Factory method
 	 * @return
 	 */
-	public static IdentifiableSource NewInstance(){
-		return new IdentifiableSource();
+	public static IdentifiableSource NewInstance(OriginalSourceType type){
+		return new IdentifiableSource(type);
 	}
 	
-	public static IdentifiableSource NewInstance(String id){
-		IdentifiableSource result = new IdentifiableSource();
+	public static IdentifiableSource NewDataImportInstance(String id){
+		IdentifiableSource result = new IdentifiableSource(OriginalSourceType.Import);
 		result.setIdInSource(id);
 		return result;
 	}
 
-	public static IdentifiableSource NewInstance(String id, String idNamespace){
-		IdentifiableSource result = NewInstance(id);
+	public static IdentifiableSource NewDataImportInstance(String id, String idNamespace){
+		IdentifiableSource result = NewDataImportInstance(id);
 		result.setIdNamespace(idNamespace);
 		return result;
 	}
+
+	public static IdentifiableSource NewDataImportInstance(String id, String idNamespace, Reference ref){
+		IdentifiableSource result = NewDataImportInstance(id, idNamespace);
+		result.setCitation(ref);
+		return result;
+	}
 	
-	public static IdentifiableSource NewInstance(String id, String idNamespace, Reference citation, String microCitation){
-		IdentifiableSource result = NewInstance(id, idNamespace);
+	public static IdentifiableSource NewInstance(OriginalSourceType type, String id, String idNamespace, Reference citation, String microCitation){
+		IdentifiableSource result = NewInstance(type);
+		result.setIdInSource(id);
+		result.setIdNamespace(idNamespace);
 		result.setCitation(citation);
 		result.setCitationMicroReference(microCitation);
 		return result;
 	}
 
-	public static IdentifiableSource NewInstance(Reference citation, String microCitation){
-		IdentifiableSource result = NewInstance();
+	public static IdentifiableSource NewPrimarySourceInstance(Reference citation, String microCitation){
+		IdentifiableSource result = NewInstance(OriginalSourceType.PrimaryTaxonomicSource);
 		result.setCitation(citation);
 		result.setCitationMicroReference(microCitation);
 		return result;
@@ -90,9 +97,19 @@ public class IdentifiableSource extends OriginalSourceBase<IdentifiableEntity>{
 	    	 optional = false)
 	@JoinColumn(name = "sourcedObj_id")
 	@NotAudited
-	private IdentifiableEntity sourcedObj;
+	private IdentifiableEntity<?> sourcedObj;
 
+// ****************** CONSTRUCTOR ********************************/	
+	
+	//for hibernate only
+	private IdentifiableSource() {
+	}
 
+	private IdentifiableSource(OriginalSourceType type) {
+		super(type);
+	}
+	
+// ********************** GETTER /SETTER *****************************/
 	/* (non-Javadoc)
 	 * @see eu.etaxonomy.cdm.model.common.IOriginalSource#getSourcedObj()
 	 */
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/LSID.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/LSID.java
index 99e313d941..2824f5b9dd 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/LSID.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/LSID.java
@@ -28,6 +28,7 @@ import com.ibm.lsid.MalformedLSIDException;
  */
 @Embeddable
 public class LSID implements Serializable {
+	private static final long serialVersionUID = -3568951541851092269L;
 
 	private String lsid;
 	
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/LSIDAuthority.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/LSIDAuthority.java
index c8a4e9dc81..5169ec6c6e 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/LSIDAuthority.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/model/common/LSIDAuthority.java
@@ -17,7 +17,6 @@ import javax.persistence.ElementCollection;
 import javax.persistence.Entity;
 import javax.persistence.FetchType;
 import javax.persistence.MapKeyColumn;
-import javax.persistence.MapKeyJoinColumn;
 import javax.persistence.Transient;
 import javax.wsdl.Definition;
 import javax.xml.bind.annotation.XmlAccessType;
@@ -50,10 +49,6 @@ import eu.etaxonomy.cdm.jaxb.NamespacesAdapter;
 @Entity
 @TypeDefs(@TypeDef(name="wsdlDefinitionUserType", typeClass=WSDLDefinitionUserType.class))
 public class LSIDAuthority extends CdmBase {
-
-	/**
-	 * 
-	 */
 	private static final long serialVersionUID = 9168994979216936689L;
 
 	public static final String AUTHORITY_ID_PREFIX = "lsidauth:";
